;	    	   *******************************************
;		   *		  STKOVF.asm		     *
;	    	   * Copyright TimeSlice, Inc. 1985, 86, 87. *
;	    	   *******************************************
;
;
include ts.inc
;
;
start_data
;
stovf	db	'*** STACK OVER FLOW ***',0 
intmsg	db	'*** INTERRUPT IN PROGRESS ***', 0
;
ifdef MICROSOFT
__aaltstkovr dd	0ffffffffH
public __aaltstkovr
endif
;
end_data
;
start_code
;
extern_code prout
extern_ptr  ovfsvc,c 
;
;
;*******
;* TS_STKOVF()
;* This routine is jump to whenever a stack overflow occurs within a process.
;* It prints a message at (0,0), and informs the user of the overflowing
;* curproc address.
;*******
routine	ts_stkovf
	cli			;hold interrupt
if !(LATTICE && ldata)
	xor	ax,ax		;reset _base
	mov	stk_base,ax
endif
	inc	_sslev		;make sure we go to sleep
	sti			;enable interrupts so machine can be rebooted
	mov	ax,ovfsvc.off	;overflow service set???
if lprog
	mov	bx,ovfsvc.sgt
	or	ax,bx
else
	test	ax,ax
endif
	jz	mpx1		;no
	xor	bx,bx		;by default: situation is 'stable'
	mov	ax,sp
	cmp	ax,_istop.off
	ja	mpx0		;no: situation is indeed 'stable'
	inc	bx		;yes: situation is 'unstable'
mpx0:	lea	si,ovfsvc
	push	bx		;flag 0: stable   1: unstable
	fncall	[si]		;call user defined overflow service
	add	sp,4		;pop flag
	pop	bp		;restore bp left by overflowing function
	ret			;simulate return of func which called overflowed
;
;	No overflow service, simply put message at top of screen
;
;	Puts stack overflow message at 0,0
;
mpx1:	mov	bp,sp
	mov	ax,offset DGROUP:stovf
if ldata
	push	ds
endif
	push	ax
	mov	ax,REVVID
	push	ax
	xor	ax,ax
	push	ax
	push	ax
	call	prout
	mov	sp,bp
;
;	put current process name at 0,1
;
	ldptr	es,di,curproc,d
	mov	ax,es:[di].pname.off ;ax <-- offset of current process name
if ldata
	push	es		;*curproc and curproc.name are in same segment
endif
	push	ax
	mov	ax,REVVID
	push	ax
	mov	ax,1
	push	ax
	dec	ax
	push	ax
	call	prout
	mov	sp,bp
;
;	check if interrupt caused overflow
;
	mov	ax,sp
	cmp	ax,_istop.off
	ja	forever
	mov	ax,offset DGROUP:intmsg
	push	ds
	push	ax
	mov	ax,REVVID	;reverse video
	push	ax
	mov	ax,2
	push	ax
	xor	ax,ax
	push	ax
	call	prout
	add	sp,30		;to avoid possible segment wrap exception
;
forever:jmp	forever
;
return	ts_stkovf
;
end_code
